<template>
  <div class="sidebar">
    <el-dialog
      v-model="visible"
      destroy-on-close
      width="100%"
      custom-class="sidebar-dialog"
      :show-close="false"
    >
      <template #title>
        <div class="h-fit">
          <div class="relative">
            <div class="flex justify-start h-[80px] items-center">
              <h2
                class="text-center text-[24px] text-[var(--title-font-color)] uppercase leading-1 font-bold mr-10 ml-[2.5rem]"
              >
                {{
                  defaultLanguageForDisplay
                    ? defaultLanguageForDisplay
                    : $t("language")
                }}
              </h2>
            </div>
            <div
              class="absolute top-[12px] right-[15px] bg-[var(--button-bg)] box-shadow text-[var(--title-font-color)] rounded-[6px] h-10 w-10 flex items-center justify-center"
            >
              <font-awesome-icon
                class="text-[27px]"
                icon="xmark"
                @click="close"
              />
            </div>
          </div>
        </div>
      </template>
      <div class="mt-10 min-h-[85.8vh] px-10">
        <ul class="grid grid-cols-1 gap-4">
          <li>
            <div
              class="w-full ml-0 flex items-center h-[40px] text-sm py-0 px-4 bg-[var(--button-bg)] border-[var(--element-border-color)] border-[1px] box-shadow-inset rounded-lg"
            >
              <img
                class="w-5 h-5 border-0 align-middle"
                :src="
                  getAssetImage(
                    `assets/materials/languageIcon/${
                      defaultLanguage ? defaultLanguage : 'en'
                    }.svg`
                  )
                "
                alt=""
              />
              <span
                class="relative left-5 max-w-full w-full opacity-100 overflow-hidden"
                >{{ defaultLanguageForDisplay }}</span
              >
              <font-awesome-icon
                icon="check"
                color="green"
                class="opacity-100 flex justify-center items-center"
              />
            </div>
          </li>
          <li v-for="lang in languages" :key="lang.ISO" class="mb-0 rounded-lg">
            <div
              class="flex items-center py-[10px] px-4 text-sm text-[var(--font-color-primary)]"
              @click="onSwithLanguage(lang.ISO)"
            >
              <img
                class="w-5 mr-[10px]"
                :src="
                  getAssetImage(`assets/materials/languageIcon/${lang.ISO}.svg`)
                "
                alt=""
              />
              <span>{{ lang.LanguageLocalName }}</span>
            </div>
          </li>
        </ul>
      </div>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import commonHelper from "@/utils/commonHelper";
import { ILanguage } from "@/models/common/language";

export default defineComponent({
  props: {
    dialogVisible: {
      type: Boolean,
      required: true,
    },
    languages: {
      type: Array as PropType<Array<ILanguage>>,
      required: true,
    },
    defaultLanguageForDisplay: {
      type: String,
      required: true,
    },
    switchLanguage: {
      type: Function,
      required: true,
    },
    defaultLanguage: {
      type: String,
      required: true,
    },
  },
  emits: ["update:dialogVisible"],
  setup(props, { emit }) {
    const { dialogVisible: visible } = toRefs(props);
    const { getAssetImage } = commonHelper;
    const close = () => {
      emit("update:dialogVisible", false);
    };
    const onSwithLanguage = (lang: string) => {
      props.switchLanguage(lang);
    };
    return {
      getAssetImage,
      close,
      visible,
      onSwithLanguage,
    };
  },
});
</script>
